unit PlugInUtils;

interface

{   NeoBook }

uses Windows, Messages, KOL, ActiveX;

const {  ,   }
  ACTIONPARAM_NONE     = 0;  {   }
  ACTIONPARAM_ALPHA    = 1;  {    - , ..  }
  ACTIONPARAM_ALPHASP  = 2;  {     ,       }
  ACTIONPARAM_NUMERIC  = 3;  {   0..9 }
  ACTIONPARAM_MIXED    = 4;  {      -  ... }
  ACTIONPARAM_FILENAME = 5;  {   }
  ACTIONPARAM_VARIABLE = 6;  {    NeoBook }
  ACTIONPARAM_DATAFILE = 7;  { ,       }
  ACTIONPARAM_OBJNAME  = 8;  {   NeoBook }
  ACTIONPARAM_MENUID   = 9;  { id   }
  ACTIONPARAM_FILENOEX = 10; {  ,     .
                                   ndFileToStream }

  MaxActionParams = 10; { . - ,  .
                          ,     10.   ? :) }

  WM_NOTIFYPLUGINOBJECT = WM_USER + 250; { ,    NeoBook.

                                                 WParam -  ,     

                                                 lParam     . :

                                                 1 =   
                                                 2 =   
                                                 3 =   }

type TAddActionProc = procedure(IDNum: INTEGER;
    Name, Hint: PChar;
    Params: array of BYTE;
    NumParams: BYTE);
  TAddFileProc = procedure(FileName: PChar; AddFlag: BOOLEAN);
  TVarGetProc = procedure(VarName: PChar; var Value: PChar);
  TVarSetProc = procedure(VarName, Value: PChar);
  TPlayActionProc = procedure(Action: PChar);
  TInterfaceProc = function(InterfaceID: INTEGER; var Data: PChar): BOOLEAN;
  TStreamProc = function(FileName: PChar; out Stream: IStream): BOOLEAN;

var nbGetVar: TVarGetProc;
  nbSetVar: TVarSetProc;
  nbPlayAction: TPlayActionProc;
  nbInterface: TInterfaceProc;
  nbFileToStream: TStreamProc;
  nbAddFile: TAddFileProc;
  nbAddAction: TAddActionProc;
  nbWinHandle: HWND;

procedure FreeStr(var S: PChar);
procedure SetStr(var Dest: PChar; const Source: string);


implementation

{  ,   .    Free  ,
    / / NeoBook.     
   ,    , 3 ... }

procedure FreeStr(var S: PChar);
begin
  if S <> nil then GlobalFree(HGLOBAL(S));
  S := nil;
end;

{   - .  ,   , 
     .        }

procedure SetStr(var Dest: PChar; const Source: string);
begin
  if Dest <> nil then GlobalFree(HGLOBAL(Dest));
  Dest := Pointer(GlobalAlloc(GMEM_FIXED, Length(Source) + 1));
  StrCopy(Dest, PChar(Source));
end;

end.

