{ KOL MCK } // Do not remove this line!
library Plugin;
//program Plugin;

{    NeoBook  memo-  KOL }

{$E nbp}

uses
KOL,
  Windows,
  Messages,
  uEditForm in 'uEditForm.pas' {EditForm},
  uDynamicalObjects in 'uDynamicalObjects.pas',
  PlugInUtils in 'PlugInUtils.pas';

//{$R *.res}

//{$R SPIN.RES} //    ,   
                // Action list NeoBook

{=================      =======================}

{    }
const
  cPlugInTitle = 'KOLMemo'; //  
  cPlugInPublisher = ' dss 2008'; // 
  cPlugInHint  = 'The Memo control on objects'; // 

{=========  NeoBook,        ========}

{ nbEditAction -      /  .
          .
   TRUE,   ,  FALSE   }

function nbEditAction(IDNum: Integer; var Params: array of PChar): Boolean;

  procedure ShowWnd;
  var
    PCR: TRect;
  begin
    Applet.Caption := cPlugInTitle + 'Create Properties';
    SetParent(Applet.Handle, GetActiveWindow);
    NewEditForm(EditForm, Applet);
    EditForm.Form.Caption := cPlugInTitle + 'Properties';
    PCR := MakeRect( 0, 0, GetSystemMetrics( SM_CXSCREEN ), GetSystemMetrics( SM_CYSCREEN ) );
    EditForm.Form.Left := (PCR.Right - PCR.Left - EditForm.Form.Width) div 2;
    EditForm.Form.Top := (PCR.Bottom - PCR.Top - EditForm.Form.Height) div 2;
    BringWindowToTop(EditForm.Form.Handle);
  end;


begin
  {   }
  Result := FALSE;

  { ,       }
  case IDNum of
    1, 3: begin {   }
        {     }
        ShowWnd;
        try
          {       }
          EditForm.EditBox1.Text := Params[0];     
          EditForm.Memo1.Text := Params[1];
          EditForm.EditBox2.Text := Params[2];

          if EditForm.Form.ShowModalEx = ID_OK then
          begin
            {   OK,        }
            SetStr(Params[0], EditForm.EditBox1.Text);
            SetStr(Params[1], EditForm.Memo1.Text);
            SetStr(Params[2], EditForm.EditBox2.Text);

            Result := TRUE;
          end;
        finally end;
      end;
    2: begin {    }
        ShowWnd;
        try
          EditForm.EditBox1.Text := Params[0];
          {    }
          EditForm.Memo1.Hide;
          EditForm.EditBox2.Hide;
          EditForm.Label2.Hide;
          EditForm.Label3.Hide;

          if EditForm.Form.ShowModalEx = IDOK then
          begin
            SetStr(Params[0], EditForm.EditBox1.Text);             
            Result := TRUE;
          end;
        finally end;
      end;  
  end; //case 
  {   }
  if Assigned(EditForm) then
  begin
    EditForm.Form.Free;
  end;//if
end;    

{ nbExecAction -    -  }

function nbExecAction(IDNum: INTEGER; var Params: array of PChar): BOOLEAN;
begin
  { ,    }
  case IDNum of
    1: Result := CreateControl(Params[0], Params[1], Params[2]);
    2: Result := RemoveControl(Params[0], TRUE);
    3: Result := SetControl(Params[0], Params[1]);
  else Result := FALSE;
  end;
end;    

{ nbMessage -         }

procedure nbMessage(MsgCode, Reserved: INTEGER);
//var I: INTEGER;
begin
  {     .    ,
           

     MsgCode:

      1 = 
      2 = 
      3 =    
      4 =    
      5 =    /  
      6 =    
      7 =   
      8 =   

  }

  case MsgCode of
    1: ; {   }
    2: ClearObjList;
    3: ; {   }
    4: ; {   }
    5: ; {   }
    6: ; {   }
    7: ; {   }
    8: ; {   }
  end;

end;


{ nbAbout -    " " }

procedure nbAbout;
begin
  MessageBox(0, cPlugInTitle + ' demo by dss', cPlugInTitle, MB_ICONINFORMATION or MB_OK);
end;

{ nbInitPlugIn - NeoBook  -    (     ) }

procedure nbInitPlugIn(WinHandle: HWND; var PlugInTitle, PlugInPublisher, PlugInHint: PChar);
begin
  {    -  }
  nbWinHandle := WinHandle;

  {   -      }
  SetStr(PlugInTitle, cPlugInTitle);

  {  }
  SetStr(PlugInPublisher, cPlugInPublisher);

  {  }
  SetStr(PlugInHint, cPlugInHint);
end;


{ nbRegisterScriptProcessor -    .
     Action Script Player  nbPlayAction }

procedure nbRegisterScriptProcessor(PlayActionProc: POINTER);
begin
  {******************************   *********************************}
  {*} nbPlayAction := @TPlayActionProc(PlayActionProc);
  {****************************************************************************}
end;

{ nbRegisterInterfaceAccess -    .
        -  nbInterface }

procedure nbRegisterInterfaceAccess(InterfaceProc: POINTER);
begin
  {******************************   *********************************}
  {*} nbInterface := @TInterfaceProc(InterfaceProc);
  {****************************************************************************}
end;

{ nbRegisterStreamAccess -    .
    t    NeoBook }

procedure nbRegisterStreamAccess(StreamProc: POINTER);
begin
  {******************************   *********************************}
  {*} nbFileToStream := @TStreamProc(StreamProc);
  {****************************************************************************}
end;

{ nbRegisterPlugIn -      }

procedure nbRegisterPlugIn(AddActionProc, AddFileProc, VarGetFunc, VarSetFunc: POINTER);
begin

  {******************************   *********************************}
  {*} nbGetVar := @TVarGetProc(VarGetFunc);
  {*} nbSetVar := @TVarSetProc(VarSetFunc);
  {*} nbAddAction := @TAddActionProc(AddActionProc);
  {*} nbAddFile := @TAddFileProc(AddFileProc);
  {****************************************************************************}

  {  AddAction    .

     ndAddAction:

    Item 1 = ID  -    
    Item 2 =  
    Item 3 =  
    Item 4 =   - . PlugInUtils
    Item 5 =  
  }

  nbAddAction(1, cPlugInTitle + 'Create', ' ',
    [ACTIONPARAM_ALPHA, ACTIONPARAM_ALPHA, ACTIONPARAM_VARIABLE], 3);
  nbAddAction(2, cPlugInTitle + 'Delete', ' ',
    [ACTIONPARAM_ALPHA], 1);
  nbAddAction(3, cPlugInTitle + 'SetParams', ' ',
    [ACTIONPARAM_ALPHA, ACTIONPARAM_ALPHA, ACTIONPARAM_VARIABLE], 3);


  { ,  ,  NeoBook,       
   ( ,   ..)

     ndAddFile:

    Item 1 =   
    Item 2 = TRUE   , FALSE  

    :

    nbAddFile( 'c:\path\somefile.xyz', TRUE );
  }    

end;


procedure DLLHandler(Reason: INTEGER);
begin
  if Reason = DLL_PROCESS_DETACH then
  begin
    {    -   ,    }
  end;
end;


{    .   }

exports nbEditAction;
exports nbExecAction;
exports nbInitPlugIn;
exports nbRegisterPlugIn;
exports nbRegisterScriptProcessor;
exports nbRegisterInterfaceAccess;
exports nbRegisterStreamAccess;
exports nbMessage;
exports nbAbout;

begin // PROGRAM START HERE -- Please do not remove this comment

{$IFDEF KOL_MCK} {$I Plugin_0.inc} {$ELSE}

  Application.Initialize;
  Application.Run;
DLLProc := @DLLHandler; //       ELSE KOL_MCK.    ?

{$ENDIF}

end.

