{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit uEditForm;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IF Defined(KOL_MCK)}{$ELSE}, mirror, Classes, Controls, mckCtrls, mckObjs, Graphics {$IFEND (place your units here->)};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  {$IF Defined(KOL_MCK)}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I TEditFormclass.inc} {$ELSE OBJECTS} PEditForm = ^TEditForm; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TEditForm.inc}{$ELSE} TEditForm = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TEditForm = class(TForm)
  {$IFEND KOL_MCK}
    KOLProject1: TKOLProject;
    EditForm: TKOLForm;
    EditBox1: TKOLEditBox;
    Label1: TKOLLabel;
    bSelectRect: TKOLButton;
    Memo1: TKOLMemo;
    Label2: TKOLLabel;
    EditBox2: TKOLEditBox;
    Label3: TKOLLabel;
    bOK: TKOLButton;
    Button1: TKOLButton;
    KOLApplet1: TKOLApplet;
    procedure bSelectRectClick(Sender: PObj);
    procedure bOKClick(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure EditFormClose(Sender: PObj; var Accept: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EditForm {$IFDEF KOL_MCK} : PEditForm {$ELSE} : TEditForm {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewEditForm( var Result: PEditForm; AParent: PControl );
{$ENDIF}

implementation

uses PlugInUtils;

{$IF Defined(KOL_MCK)}{$ELSE}{$R *.DFM}{$IFEND}

{$IFDEF KOL_MCK}
{$I uEditForm_1.inc}
{$ENDIF}

procedure TEditForm.bSelectRectClick(Sender: PObj);
var
  Data: PChar;
begin
  { Load the current pub's subroutine names into combobox... }
  if Assigned(nbInterface) then
  try
    Data := nil;
    SetStr(Data, EditBox1.Text);
    if nbInterface(8, Data) then
      EditBox1.Text := string(Data);
  finally
    FreeStr(Data);
  end;
end;

procedure TEditForm.bOKClick(Sender: PObj);
begin
  Form.ModalResult := ID_OK;
end;

procedure TEditForm.Button1Click(Sender: PObj);
begin
  Form.ModalResult := ID_CANCEL;
end;

procedure TEditForm.EditFormClose(Sender: PObj; var Accept: Boolean);
begin
  Accept := False;
  Form.ModalResult := -1; 
end;

end.
